% interprof
%
% Les donnes acquises par les sondes se decoupent naturellement en blocs
% On est pourtant amens au cours de leur interpretation  raisonner en 
% fonction de la profondeur.
% L'idee est d'alors d'utiliser la discrtisation de la profondeur qui tourne autour du centimetre
% C'est evidemment trs lourd si on s'amuse an utiliser ce script sur une grande distance.
% Ce script sert surtout a rendre plus precise les tudes menees avec sinusoide et viewforage.
%
%
% Aide modifiee le 27/11/01
% DOAN Mai Linh - IPGP

function [datainterp,profinterp,longueur]=interprof(data,prof,V)

% Analyse des donnees
if ~ischar(data)
    %Gestion des paramtre
    % accentuation des contrastes :
    switch nargin
     case {0, 1}
      disp('Aucune donnee de profondeur n''a ete rentree');
      return
     case 2
      disp('interpolation en cours...')
     case 3;
      data=donnee(V(1):V(2),:);
      prof=prof(V(1):V(2));
     otherwise
      return
    end
end   

%if ~isequal(length(data),length(prof))
%    disp('Les dimensions des matrices rentrees ne correspondent pas');
%    return;
%end

% Le nouveau pas d'echantillonage est de 1 cm
profmin=min(prof);
profmax=max(prof);
profinterp=profmin:0.01:profmax;

% Cette methode ne marche que pour les fichiers f40
datainterp=zeros(length(profinterp),size(data,2));

% Il reste  savoir quelles cases on peut deja remplir
% C'est plus facile si tout est deja ordonne
[prof,ordre]=sort(prof);
data=data(ordre,:);

% On limine les doublons
[prof,reste]=unique(prof);
data=data(reste,:);

% On contruit en remontant la matrice de profondeur la matrice datainterp
[X,Y]=meshgrid(1:size(data,2),prof);
[XI,YI]=meshgrid(1:size(data,2),profinterp);
%datainterp=interp2(X,Y,data,XI,YI,'linear');
datainterp=interp2(X,Y,data,XI,YI,'nearest');
longueur=length(profinterp);  
